package OOTPOU::Admin;

use strict;
use vars qw(@ISA);
use OOTPOU::Page;
use OOTPOU::Utils;
use OOTPOU::HTMLUtils;

@ISA = "OOTPOU::Page";

sub printPage {
    my ($self) = @_;

    if (!$self->{INFO}->{ISCOMMISH}) {
        return;
    }

    if ($self->{PARAMS}->{resetPwd} == 1) {
        open (IN, 'OOTPOU/users.txt');
        open (OUT, '>OOTPOU/users.tmp');
        while (<IN>) {
            if (/^$self->{PARAMS}->{resetPassword}:/) {
                print OUT "$self->{PARAMS}->{resetPassword}:baseball\n";
            }
            else {
                print OUT $_;
            }
        }
        close (OUT);
        close (IN);
        `mv OOTPOU/users.tmp OOTPOU/users.txt`;
    }
    elsif ($self->{PARAMS}->{loginAsUser} == 1) {

    }
    elsif ($self->{PARAMS}->{adminSave}) {
        $self->saveSettings();
    }

    my %scales;
    $scales{0} = 'Scouted';
    $scales{5} = '1-5';
    $scales{8} = '2-8';
    $scales{10} = '1-10';
    $scales{20} = '1-20';
    $scales{80} = '20-80';
    $scales{100} = '1-100';
    my $key;

    $self->javaScript();
    print '<form name="admin" method="post" onsubmit="return doSubmit();">';
    print '<input type="hidden" name="page" value="admin">';
    print '<input type="hidden" name="DOPAGESHID">';
    print '<input type="hidden" name="resetPwd">';
    print '<input type="hidden" name="loginAsUser">';
    print "<tr><td colspan=2>\n";
    print "<table class=\"lpo\" width=\"100%\"><tr><td rowspan=2>\n";
    print "<table class=\"lpo\" cellspacing=\"0\" cellpadding=\"1\">\n";
    print "<tr><td colspan=2 class=\"h2_l\" width=520>Parameters\n";
    print "</td></tr>\n";
    print "<tr><td>\n";
    print "Server URL</td><td>";
    print "<input type=\"text\" name=\"SITE\" size=50 value=\"$self->{INFO}->{SITE}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "League HTML reports folder</td><td>";
    print "<input type=\"text\" name=\"PAGES\" size=50 value=\"$self->{INFO}->{PAGES}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "CGI folder</td><td>";
    print "<input type=\"text\" name=\"SCRIPTS\" size=50 value=\"$self->{INFO}->{SCRIPTS}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "CSV directory on server</td><td>";
    print "<input type=\"text\" name=\"CSV\" size=50 value=\"$self->{INFO}->{CSV}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "HTML root directory on server</td><td>";
    print "<input type=\"text\" name=\"HTML_DIR\" size=50 value=\"$self->{INFO}->{HTML_DIR}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "Export directory on server</td><td>";
    print "<input type=\"text\" name=\"EXPORT_DIR\" size=50 value=\"$self->{INFO}->{EXPORT_DIR}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "League Name</td><td>";
    print "<input type=\"text\" name=\"LEAGUE_NAME\" size=50 value=\"$self->{INFO}->{LEAGUE_NAME}\"/>\n";
    print "</td></tr><tr><td>\n";
    print "Rating Scale</td><td>";
    print "<select name=\"RATINGS\">\n";
    my @keys = sort {$a <=> $b} (keys %scales);
    foreach $key (@keys) {
        print "<option value=\"$key\"";
        if ($self->{INFO}->{RATINGS} == $key) {
            print ' selected';
        }
        print ">$scales{$key}</option>\n";
    }
    print "</select></td></tr><tr><td>\n";
    print "Talent Scale</td><td>";
    print "<select name=\"TALENT\">\n";
    @keys = sort {$a <=> $b} (keys %scales);
    foreach $key (@keys) {
        print "<option value=\"$key\"";
        if ($self->{INFO}->{TALENT} == $key) {
            print " selected";
        }
        print ">$scales{$key}</option>\n";
    }
    print "</select></td></tr><tr><td>\n";


    print "</td></tr>\n";
    print "</table></td>\n";
    print "<td valign=\"top\" align=\"right\" width=300>\n";
    print "<table class=\"lpo\" width=\"100%\" cellspacing=\"0\" cellpadding=\"1\">\n";
    print "<tr><td class=\"h2_l\">\n";
    print "Enabled Pages\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"ASPAGE\"";
    if ($self->{INFO}->{ASPAGE}) {
        print " checked";
    }
    print ">All-Star</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"DEVPAGE\"";
    if ($self->{INFO}->{DEVPAGE}) {
        print " checked";
    }
    print ">Development</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"DRAFTPAGE\"";
    if ($self->{INFO}->{DRAFTPAGE}) {
        print " checked";
    }
    print ">Draft</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"EXPPAGE\"";
    if ($self->{INFO}->{EXPPAGE}) {
        print " checked";
    }
    print ">Export</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"LASTSIMPAGE\"";
    if ($self->{INFO}->{LASTSIMPAGE}) {
        print " checked";
    }
    print ">Last Sim</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"MANAGERPAGE\"";
    if ($self->{INFO}->{MANAGERPAGE}) {
        print " checked";
    }
    print ">Manager</input>\n";
    print "</td></tr><tr><td class=\"s1_2\">\n";
    print "<input type=\"checkbox\" name=\"DOPAGES\" value=\"RATPAGE\"";
    if ($self->{INFO}->{RATPAGE}) {
        print " checked";
    }
    print ">Ratings</input>\n";

    print "</td></tr></table>\n";
    print "</td></tr><tr><td align=\"right\" valign=\"bottom\">\n";
    print "<br/><input type=\"submit\" name=\"adminSave\" value=\"Save\"/></td></tr>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "<tr><td>\n";

    if (-e "$self->{INFO}->{CSV}/teams.csv"){
        my $id;
        my %teamsByID;
        open (IN, "$self->{INFO}->{CSV}/teams.csv");
        while (<IN>)
        {
            if (/,0,"[^,]*?"\s*$/ && /^(\d+),"(.*?)","(\w+)","(.*?)",".*?",".*?",\d+,\d+,$self->{INFO}->{LEAGUEID},/)
            {
                $teamsByID{$1} = $4;
            }
        }
        close(IN);


        my $optionText = '';
        my $name;
        open (IN, "$self->{INFO}->{CSV}/human_managers.csv");
        while (<IN>) {
            if (/^(\d+),(\d+),"(.*?)","(.*?)",".*?",\d+,".*?",\d+,\d+,\d+,\d+,\d+,\d+,\d+,\d+,\d+,(\d+),/) {
                $id = $1;
                if ($5 > 0) {
                    $name = "$3 $4 ($teamsByID{$5})";
                    $name =~ s/\\\"/\"/g;
                    $optionText .= "<option value=\"$id\">$name</option>\n";
                }
            }
        }
        print "<table><tr><td><form>Login as user: ";
        print "<select name=\"loginUser\">\n";
        print $optionText;
        print "</select>&nbsp;<input type=\"submit\" value=\"Go\" onclick=\"document.forms[0].loginAsUser.value='1';\"></input>\n";
        print "</td></tr></table>\n";
        print "<table><tr><td><form>Reset password to 'baseball' for user: ";
        print "<select name=\"resetPassword\">\n";
        print $optionText;
        print "</select>&nbsp;<input type=\"submit\" value=\"Go\" onclick=\"document.forms[0].resetPwd.value='1';\"></input>\n";
        print "</td></tr></table>\n";
    }
    print "</form>";

}

sub saveSettings {

    my ($self) = @_;
    open (OUT, ">OOTPOU/setup.txt");
    print OUT "SITE:$self->{PARAMS}->{SITE}\n";
    print OUT "PAGES:$self->{PARAMS}->{PAGES}\n";
    print OUT "CSV:$self->{PARAMS}->{CSV}\n";
    print OUT "HTML_DIR:$self->{PARAMS}->{HTML_DIR}\n";
    print OUT "SCRIPTS:$self->{PARAMS}->{SCRIPTS}\n";
    print OUT "EXPORT_DIR:$self->{PARAMS}->{EXPORT_DIR}\n";
    print OUT "LEAGUE_NAME:$self->{PARAMS}->{LEAGUE_NAME}\n";
    print OUT "RATINGS:$self->{PARAMS}->{RATINGS}\n";
    print OUT "TALENT:$self->{PARAMS}->{TALENT}\n";

    my @enabledPages = split /1/, $self->{PARAMS}->{DOPAGESHID};
    my %pages;
    my $page;
    $pages{ASPAGE}      = 0;
    $pages{DEVPAGE}     = 0;
    $pages{DRAFTPAGE}   = 0;
    $pages{EXPPAGE}     = 0;
    $pages{LASTSIMPAGE} = 0;
    $pages{MANAGERPAGE} = 0;
    $pages{RATPAGE}     = 0;
    foreach $page (@enabledPages) {
        $pages{$page} = 1;
    }
    foreach $page (keys %pages) {
        print OUT "$page:$pages{$page}\n";
        $self->{INFO}->{$page} = $pages{$page};
    }

    $self->{INFO}->{SITE} = $self->{PARAMS}->{SITE};
    $self->{INFO}->{PAGES} = $self->{PARAMS}->{PAGES};
    $self->{INFO}->{CSV} = $self->{PARAMS}->{CSV};
    $self->{INFO}->{HTML_DIR} = $self->{PARAMS}->{HTML_DIR};
    $self->{INFO}->{SCRIPTS} = $self->{PARAMS}->{SCRIPTS};
    $self->{INFO}->{EXPORT_DIR} = $self->{PARAMS}->{EXPORT_DIR};
    $self->{INFO}->{LEAGUE_NAME} = $self->{PARAMS}->{LEAGUE_NAME};
    $self->{INFO}->{RATINGS} = $self->{PARAMS}->{RATINGS};
    $self->{INFO}->{TALENT} = $self->{PARAMS}->{TALENT};
}

sub javaScript {
print <<EOF
<script type="text/javascript">
<!--
    function doSubmit() {
        var boxes = document.forms[0].DOPAGES;
        var hidden = document.forms[0].DOPAGESHID;
        hidden.value='';
        for (var i=0; i<boxes.length; i++) {
            if (boxes[i].checked) {
                if (hidden.value == '') {
                    hidden.value =  boxes[i].value;
                }
                else {
                    hidden.value = hidden.value + '1' + boxes[i].value;
                }
            }
        }
        return true;
    }
//-->
</script>
EOF
}

1
